#include "Common.h"

#define IX(i,j,k) ((i)+(Nx+2)*(j)+(Nx+2)*(Ny+2)*(k))
#define SWAP(x0,x) {float * tmp=x0;x0=x;x=tmp;}
#define FOR_EACH_CELL for ( i=1 ; i<=Nx ; i++ ) { for ( j=1 ; j<=Ny ; j++ ) { for ( k=1 ; k<=Nz ; k++) {
#define END_FOR }}}

template<class T>void add_source ( IVector size, Grid<T> sim, Grid<T> forces, float dt ) {
	int i, s=(size.x+2)*(size.y+2)*(size.z+2);

	for ( i=0 ; i<s ; i++ ) 
		sim[i] = sim[i]+forces[i]*dt;
}

void set_bnd ( int Nx, int Ny, int Nz, int b, float *x) {
//void set_bnd ( IVector &size, int b, Grid<FVector> &sim ) {
	int i;
	int j;
	int k;


	/*for( i=1; i<size.x-1; i++){
		for( j=1; j<size.y-1; j++){
			sim.getCell(IVector(i, j, 0))= b==0 ? sim.getCell(IVector(i, j, 1)) : -sim.getCell(IVector(i, j, 1));

		}



	}*/


	for ( i=1 ; i<=Nx ; i++ ) {
	  for ( j=1 ; j <=Ny ; j++ ) {
		x[IX(i  ,j  ,0  )] = b==3 ? -x[IX(i,j,1)] : x[IX(i,j,1)];
		x[IX(i  ,j  ,Nz+1)] = b==3 ? -x[IX(i,j,Nz)] : x[IX(i,j,Nz)];
	  }
	  for ( k=1 ; k<=Nz ; k++ ) {
		x[IX(i  ,0   ,k  )] = b==2 ? -x[IX(i,1,k)] : x[IX(i,1,k)];
		x[IX(i  ,Ny+1,k  )] = b==2 ? -x[IX(i,Ny,k)] : x[IX(i,Ny,k)];
	  }
	}


	for ( j=1 ; j<=Ny ; j++ ) {
	  for ( k=1 ; k<=Nz ; k++ ) {
	    x[IX(0   ,j  ,k  )] = b==1 ? -x[IX(1,j,k)] : x[IX(1,j,k)];
	    x[IX(Nx+1,j  ,k  )] = b==1 ? -x[IX(Nx,j,k)] : x[IX(Nx,j,k)];
	  }
	}

	//Pour les coins du cube, on fait la moyenne des voisins
	x[IX(0   ,0   ,0   )] = 0.33f*(x[IX(1   ,0   ,0   )]+x[IX(0   ,1   ,0   )]+x[IX(0   ,0   ,1   )]);
	x[IX(0   ,Ny+1,0   )] = 0.33f*(x[IX(1   ,Ny+1,0   )]+x[IX(0   ,Ny  ,0   )]+x[IX(0   ,Ny+1,1   )]);
	x[IX(0   ,0   ,Nz+1)] = 0.33f*(x[IX(1   ,0   ,Nz+1)]+x[IX(0   ,1   ,Nz+1)]+x[IX(0   ,0   ,Nz  )]);
	x[IX(0   ,Ny+1,Nz+1)] = 0.33f*(x[IX(1   ,Ny+1,Nz+1)]+x[IX(0   ,Ny  ,Nz+1)]+x[IX(0   ,Ny+1,Nz  )]);
	x[IX(Nx+1,0   ,0   )] = 0.33f*(x[IX(Nx  ,0   ,0   )]+x[IX(Nx+1,1   ,0   )]+x[IX(Nx+1,0   ,1   )]);
	x[IX(Nx+1,Ny+1,0   )] = 0.33f*(x[IX(Nx  ,Ny+1,0   )]+x[IX(Nx+1,Ny  ,0   )]+x[IX(Nx+1,Ny+1,1   )]);
	x[IX(Nx+1,0   ,Nz+1)] = 0.33f*(x[IX(Nx  ,0   ,Nz+1)]+x[IX(Nx+1,1   ,Nz+1)]+x[IX(Nx+1,0   ,Nz  )]);
	x[IX(Nx+1,Ny+1,Nz+1)] = 0.33f*(x[IX(Nx  ,Ny+1,Nz+1)]+x[IX(Nx+1,Ny  ,Nz+1)]+x[IX(Nx+1,Ny+1,Nz  )]);
}

void lin_solve ( int Nx, int Ny, int Nz, int b, float * x, float * x0, float a, float c )
{
	int i, j, k, step;

	for ( step=0 ; step<20 ; step++ ) {
		FOR_EACH_CELL
		  x[IX(i,j,k)] = (x0[IX(i,j,k)] + a*(x[IX(i-1,j,k)]+x[IX(i+1,j,k)]+x[IX(i,j-1,k)]+x[IX(i,j+1,k)]+x[IX(i,j,k-1)]+x[IX(i,j,k+1)]))/c;
		END_FOR
		set_bnd ( Nx, Ny, Nz, b, x );
	}
}

void diffuse ( int Nx, int Ny, int Nz, int b, float * x, float * x0, float diff, float dt )
{
	float a=dt*diff*Nx;
	lin_solve ( Nx, Ny, Nz, b, x, x0, a, 1+6*a );
}

void advect ( int Nx, int Ny, int Nz, int b, float * d, float * d0, float * u, float * v, float * w, float dt )
{
	int i, j, k, i0, j0, k0, i1, j1, k1;
	float x, y, z, r0, s0, t0, r1, s1, t1, dt0;

	dt0 = dt*Nx;
	FOR_EACH_CELL
	        x = i-dt0*u[IX(i,j,k)]; y = j-dt0*v[IX(i,j,k)]; z = k-dt0*w[IX(i,j,k)];
		if (x<0.5f) x=0.5f; if (x>Nx+0.5f) x=Nx+0.5f; i0=(int)x; i1=i0+1;
		if (y<0.5f) y=0.5f; if (y>Ny+0.5f) y=Ny+0.5f; j0=(int)y; j1=j0+1;
		if (z<0.5f) z=0.5f; if (z>Nz+0.5f) z=Nz+0.5f; k0=(int)z; k1=k0+1;
		r1 = x-i0; r0 = 1-r1; s1 = y-j0; s0 = 1-s1; t1 = z-k0; t0 = 1-t1;
		d[IX(i,j,k)] =
		  r0*(s0*(t0*d0[IX(i0,j0,k0)]+t1*d0[IX(i0,j0,k1)])+
		      s1*(t0*d0[IX(i0,j1,k0)]+t1*d0[IX(i0,j1,k1)]))+
		  r1*(s0*(t0*d0[IX(i1,j0,k0)]+t1*d0[IX(i1,j0,k1)])+
		      s1*(t0*d0[IX(i1,j1,k0)]+t1*d0[IX(i1,j1,k1)]));
	END_FOR
	set_bnd ( Nx, Ny, Nz, b, d );
}

void project ( int Nx, int Ny, int Nz, float * u, float * v, float * w, float * p, float * div )
{
	int i, j, k;

	FOR_EACH_CELL
		div[IX(i,j,k)] = -0.5f*(u[IX(i+1,j,k)]-u[IX(i-1,j,k)]+v[IX(i,j+1,k)]-v[IX(i,j-1,k)]+w[i,j,k+1]-w[i,j,k-1])/Nx;
		p[IX(i,j,k)] = 0;
	END_FOR	
	set_bnd ( Nx, Ny, Nz, 0, div ); set_bnd ( Nx, Ny, Nz, 0, p );

	lin_solve ( Nx, Ny, Nz, 0, p, div, 1, 6 );

	FOR_EACH_CELL
		u[IX(i,j,k)] -= 0.5f*Nx*(p[IX(i+1,j,k)]-p[IX(i-1,j,k)]);
		v[IX(i,j,k)] -= 0.5f*Nx*(p[IX(i,j+1,k)]-p[IX(i,j-1,k)]);
       	w[IX(i,j,k)] -= 0.5f*Nx*(p[IX(i,j,k+1)]-p[IX(i,j,k-1)]);
	END_FOR
	set_bnd ( Nx, Ny, Nz, 1, u ); set_bnd ( Nx, Ny, Nz, 2, v ); set_bnd ( Nx, Ny, Nz, 3, w );
}

//SOLVEUR DE DENSITE
void dens_step ( int Nx, int Ny, int Nz, float * x, float * x0, float * u, float * v, float * w, float diff, float dt )
{
  IVector dd(Nx, Ny, Nz);

        //Ajout des sources
	add_source<float> ( IVector(Nx, Ny, Nz), Grid<float>(x, IVector(Nx, Ny, Nz)), Grid<float>(x0, IVector(Nx, Ny, Nz)), dt );

	//Diffusion
	SWAP ( x0, x );
	diffuse ( Nx, Ny, Nz, 0, x, x0, diff, dt );

	//Advection
	SWAP ( x0, x );
	advect ( Nx, Ny, Nz, 0, x, x0, u, v, w, dt );
}

//SOLVEUR DE VITESSE
void vel_step ( int Nx, int Ny, int Nz, float * u, float * v, float * w, float * u0, float * v0, float * w0, float visc, float dt )
{
        //Ajout des sources
	//add_source ( IVector(Nx, Ny, Nz), u, u0, dt );
	//add_source ( IVector(Nx, Ny, Nz), v, v0, dt );
	//add_source ( IVector(Nx, Ny, Nz), w, w0, dt );

	add_source<float> ( IVector(Nx, Ny, Nz), Grid<float>(u, IVector(Nx, Ny, Nz)), Grid<float>(u0, IVector(Nx, Ny, Nz)), dt );
	add_source<float> ( IVector(Nx, Ny, Nz), Grid<float>(v, IVector(Nx, Ny, Nz)), Grid<float>(v0, IVector(Nx, Ny, Nz)), dt );
	add_source<float> ( IVector(Nx, Ny, Nz), Grid<float>(w, IVector(Nx, Ny, Nz)), Grid<float>(w0, IVector(Nx, Ny, Nz)), dt );

	//Diffusion
	SWAP ( u0, u ); diffuse ( Nx, Ny, Nz, 1, u, u0, visc, dt );
	SWAP ( v0, v ); diffuse ( Nx, Ny, Nz, 2, v, v0, visc, dt );
	SWAP ( w0, w ); diffuse ( Nx, Ny, Nz, 3, w, w0, visc, dt );

	//Projection
	project ( Nx, Ny, Nz, u, v, w, u0, v0 );

	//Advection
	SWAP ( u0, u );
	SWAP ( v0, v );
	SWAP ( w0, w );
	advect ( Nx, Ny, Nz, 1, u, u0, u0, v0, w0, dt );
	advect ( Nx, Ny, Nz, 2, v, v0, u0, v0, w0, dt );
	advect ( Nx, Ny, Nz, 3, w, w0, u0, v0, w0, dt );

	//Projection
	project ( Nx, Ny, Nz, u, v, w, u0, v0 );
}

